// Author : Pierre Vuillemin (2016)
// License : CECILL

function newVar = %s_m_sopiVar(A,var)
   // Overloading of the multiplication between a matrix and a sopiVar.
   //
   // Inputs
   // ------
   // A (matrix): a matrix
   // var (sopiVar): a sopiVar
   //
   // Returns
   // -------
   // A sopiVar containing a tree representing the operation.
   //
   // Example
   // -------
   // sopi_begin()
   // x = sopi_var(1)
   // y = 3*x
   // y.operator // should be "times"
   // y.args(1)  // should be a constant sopiVar containing 3
   // y.args(2)  // should be x
   //   
   sopi_print(5,"Performing matrix*sopiVar.\n")
   newSize        = sopi_checkSizesCoherence(A, var, "times")
   if isscalar(A) then
      A = A * eye(size(var,1), size(var,1))
   end
   Avar           = sopi_constant(A)
   newVar         = sopi_newVar()
   newVar.size    = newSize
   newVar.operator = "times"
   newVar.args    = list(Avar, var)
endfunction
