// Author : Pierre Vuillemin (2016)
// License : CECILL

function out = %sopiProp_e(varargin)
   // Overloading of the extraction for a sopiProp
   //
   // Inputs
   // ------
   // 
   //
   // Returns
   // -------
   // The desired field or answer to the test.
   //
   p = varargin($)
   if length(varargin) == 2 & typeof(varargin(1)) == "string" then
      field             = varargin(1)
      validFieldNames   = fieldnames(p)
      if or(field == validFieldNames) then
         out = getfield(field, p)
      else
         out = sopi_performPropTest(p,field)
      end
   else
      error("Invalid extraction")
   end
endfunction

function out = sopi_performPropTest(p, field)
   select field
   case "isPoly"
      out = or(p.sets == "poly")
   case "isRat"
      out =  or(p.sets == "rat")
   case "polyOrder"
      out = p.data.order
   case "isDiff"
      out =  or(p.sets == "diff")
   case "isConvex"
      out =  or(p.sets == "convex")
   case "isConcave"
      out =  or(p.sets == "concave")
   case "isConstant"
      out =  p.isPoly & p.polyOrder == 0
   case "isLinear"
      out =  p.isPoly & p.polyOrder == 1
   case "sign"
      out = p.data.sign
   else
      error("Invalid field")
   end
endfunction
