// Author : Pierre Vuillemin (2016)
// License : CECILL

function fun = sopi_toScilabFunction(var)
   data = list()
   dep   = var.depends;
   nvar  = length(dep)
   funHead = "y = innerSopiFun("
   for i = 1:nvar
      funHead = strcat([funHead,"var_",string(dep(i).id),','])
   end
   funHead = strcat([funHead, "data)"])
   [funStr, data] = sopi_toScilabFunRec(var, "y=", list())
   deff(funHead,funStr)
   fun      = sopi_lambdaFun(innerSopiFun, data)
endfunction

function [funStr, data] = sopi_toScilabFunRec(var, funStr, data)
   if var.isElementary
      funStr = strcat([funStr,"var_",string(var.id)])
   else
      select var.operator
      case "constant"
         data($+1)   = var.args(1)
         funStr      =  strcat([funStr, "data(",string(length(data)),")"])
      case "sum"
         [funStr, data] = sopi_toScilabFunRec(var.args(1), funStr, data)
         funStr         = strcat([funStr,"+"])
         [funStr, data] = sopi_toScilabFunRec(var.args(2), funStr, data)
      case "times"
         [funStr, data] = sopi_toScilabFunRec(var.args(1), funStr, data)
         funStr         = strcat([funStr, "*"])
         [funStr, data] = sopi_toScilabFunRec(var.args(2), funStr, data)
      else
         error('nope')
      end
   end
endfunction
